<?php

/* Оплата через ASSIST */
class system_of_pay_handler
{
	/* Идентификатор сайта (Merchant_ID) в системе ASSIST, например, 123456 */
	var $Merchant_ID = '123456';

	/* Идентификатор валюты.
	Указывается ID валюты рубли (RUR)
	*/
	var $assist_currency_id = 1;

	/*
	Использовать оплату кредитными картами
	1 - да, использовать;
	0 - не использовать, только Webmoney и Яндекс.Деньги.
	*/
	var $use_credit_card = 1;

	/*
	Режим работы магазина:
	1 - тестовый режим;
	0 - боевой режим (не забудьте изменить режим магазина в системе ASSIST).
	*/
	var $test_mode = 1;

	/**
	 * Обработка статуса оплаты
	 *
	 */
	function ProcessResult()
	{

	}

	/**
	 * Отображает стартовую страницу для оплаты через ASSIST.
	 *
	 */
	function ShowPurseRequest()
	{
		$shop = & singleton('shop');

		/* ID платежной системы берем из сессии */
		$system_of_pay_id = to_int($_SESSION['system_of_pay_id']);
		$row_system_of_pay = $shop->GetSystemOfPay($system_of_pay_id);

		if ($row_system_of_pay)
		{
			$shop_id = $row_system_of_pay['shop_shops_id'];
		}
		else
		{
			return false;
		}

		/* Получаем id текущего пользователя сайта */
		if (class_exists('SiteUsers'))
		{
			/* Получаем id текущего пользователя сайта */
			$SiteUsers = & singleton('SiteUsers');
			$site_users_id = $SiteUsers->GetCurrentSiteUser();
		}
		else
		{
			$site_users_id = false;
		}

		// статус платежа, по умолчанию 0
		$order_row['status_of_pay'] = 0;

		// дата платежа, по умолчанию пустая строка
		$order_row['date_of_pay'] = '';

		$order_row['description'] = to_str($_SESSION['description']);

		// описание и системная информация, по умолчанию пустая строка
		if (to_str($_SESSION['shop_coupon_text']) != '')
		{
			$order_row['description'] .= "Купон на скидку: ".to_str($_SESSION['shop_coupon_text'])."\n";
		}

		if (!isset($_SESSION['last_order_id']))
		{
			$_SESSION['last_order_id'] = 0;
		}

		// Если заказ еще не был оформлен
		if ($_SESSION['last_order_id'] == 0)
		{
			/* Оформляем заказ */
			$order_id = $shop->ProcessOrder($shop_id, $site_users_id, $system_of_pay_id, $order_row);
		}
		else
		{
			$order_id = $_SESSION['last_order_id'];
		}

		// Оформление заказа произошло успешно
		if ($order_id > 0)
		{
			if (!class_exists('SiteUsers'))
			{
				/* Класс пользователей сайта не существует, дописываем информацию о заказчике
				в поле shop_order_description из текущей сессии */
				if ($order_row)
				{
					/* Описание заказчика */
					$order_row['description'] .= "Информация о заказчике:\n"
					."Имя: ".to_str($_SESSION['site_users_name'])."\n"
					."Фамилия: ".to_str($_SESSION['site_users_surname'])."\n"
					."Отчество: ".to_str($_SESSION['site_users_patronymic'])."\n"
					."E-Mail: ".to_str($_SESSION['site_users_email'])."\n"
					."Телефон: ".to_str($_SESSION['site_users_phone'])."\n"
					."Факс: ".to_str($_SESSION['site_users_fax'])."\n"
					."Адрес: ".to_str($_SESSION['full_address'])."\n";

					/* Дополнительная информация о заказе */
					$order_row['system_information'] = to_str($_SESSION['system_information']);

					/* Обязательно добавляем идентификатор! */
					$order_row['id'] = $order_id;

					$shop->InsertOrder($order_row);
				}
			}

			$order_row = $shop->GetOrder($order_id);

			if ($order_row)
			{
				$this->PrintOrder($order_id);
			}

			$shop_row = $shop->GetShop($shop_id);

			if ($_SESSION['last_order_id'] == 0)
			{
				$structure = & singleton('Structure');
				$structure_row = $structure->GetStructureItem(to_int($shop_row['structure_id']));

				$lib = new lib();
				$LA = $lib->LoadLibPropertiesValue(to_int($structure_row['lib_id']), to_int($structure_row['structure_id']));

				$date_str = date("d.m.Y H:i:s");

				if (trim(to_str($order_row['shop_order_account_number'])) != '')
				{
					$shop_order_account_number = trim(to_str($order_row['shop_order_account_number']));
				}
				else
				{
					$shop_order_account_number = $order_id;
				}

				/* Отправляем письмо заказчику */
				$shop->SendMailAboutOrder($shop_id,
				$order_id,
				$site_users_id,
				to_str($LA['xsl_letter_to_admin']),
				to_str($LA['xsl_letter_to_user']),
				$order_row['shop_order_users_email'],
				array('admin-content-type' => 'html',
				'user-content-type' => 'html',
				'admin-subject' => sprintf($GLOBALS['MSG_shops']['shop_order_admin_subject'], $shop_order_account_number, $shop_row['shop_shops_name'], $date_str),
				'user-subject' => sprintf($GLOBALS['MSG_shops']['shop_order_user_subject'], $shop_order_account_number, $shop_row['shop_shops_name'], $date_str),
				'email_from_admin' => $order_row['shop_order_users_email']));
			}

			// Сохраняем ID последнего оформленного заказа ТОЛЬКО ПОСЛЕ ОТПРАВКИ ПИСЬМА
			$_SESSION['last_order_id'] = $order_id;
		}
		else
		{
			switch ($order_id)
			{
				case -1:
					{
						?><div id="error">Ошибка вставки заказа в базу данных. Обратитесь к администратору.</div><?php
						break;
					}
				case -2:
					{
						?><div id="error">Ошибка - не найден магазин. Обратитесь к администратору.</div><?php
						break;
					}
				case -3:
					{
						?><div id="error">Ошибка - корзина пуста. Добавьте товар в корзину и оформите заказ.</div><?php
						break;
					}
			}
		}

		return true;
	}

	/**
	 * Метод, запускающий выполнение обработчика
	 *
	 */
	function Execute()
	{
		/* Иначе оформляем заказ и отображаем стартовую страницу для оплаты */
		$this->ShowPurseRequest();

		return true;
	}

	/**
	 * Метод для отображения формы заказа для печати.
	 *
	 * @param int $order_id идентификатор заказа
	 */
	function PrintOrder($order_id)
	{
		$shop = & singleton('shop');

		$order_row = $shop->GetOrder($order_id);
		if (!$order_row)
		{
			return false;
		}

		if ($order_row)
		{
			$shop_row = $shop->GetShop($order_row['shop_shops_id']);

			/* Делаем перерасчет суммы в валюту */
			$shop_currency_id = $shop_row['shop_currency_id'];

			/* Определяем коэффициент пересчета */
			$coefficient = $shop->GetCurrencyCoefficientToShopCurrency($shop_currency_id, $this->assist_currency_id );

			$currency_row = $shop->GetCurrency($shop_currency_id);

			$order_sum = $shop->GetOrderSum($order_id);

			// округляем до десятых после запятой
			$sum = round($order_sum * $coefficient, 2);

			/* Информация об алиасе сайта */
			$site = & singleton ('site');
			$site_alias = $site->GetCurrentAlias($shop_row['site_id']);

			/* Получаем путь к магазину */
			$Structure = & singleton('Structure');
			$shop_path = "/".$Structure->GetStructurePath($shop_row['structure_id'], 0);

			$handler_url = 'http://'.$site_alias.$shop_path;

			// Определяем город
			$row_city = $shop->GetCity($order_row['shop_city_id']);
			$city_name = to_str($row_city['shop_city_name']);

			?>
			<h1>Оплата через систему ASSIST</h1>

			<p>
			<a href="http://www.assist.ru" target="_blank">
			<img src="http://www.assist.ru/images/assist_logo.gif" width="155" height="49" border="0" alt="Система электронных платежей">
			</a>
			</p>

			<p>Сумма к оплате составляет <strong><?php echo $sum?> <?php echo $currency_row['shop_currency_name']?></strong></p>

			<?php
			if (mb_strlen(trim($order_row['shop_order_users_surname'])) == 0
			|| mb_strlen(trim($order_row['shop_order_users_name'])) == 0)
			{
				?>
				<p>Для оплаты, пожалуйста, укажите имя и фамилию в личных данных.</p>
				<?php
			}
			else
			{
				?>
				<p>Для оплаты нажмите кнопку "Оплатить".</p>

				<p style="color: rgb(112, 112, 112);">
				Внимание! Нажимая &laquo;Оплатить&raquo; Вы подтверждаете передачу контактных данных на сервер ASSIST.RU для оплаты.
				</p>

				<form name="form1" action="https://payments.paysecure.ru/pay/order.cfm" method="POST">
				<input type="hidden" name="Merchant_ID" value="<?php echo $this->Merchant_ID?>">
				<input type="hidden" name="OrderNumber" value="<?php echo $order_row['shop_order_account_number']?>">
				<input type="hidden" type="text" name="TestMode" value="<?php echo $this->test_mode ?>">
				<input type="hidden" name="OrderAmount" value="<?php echo $sum?>">
				<input type="hidden" name="OrderCurrency" value="RUR">
				<input type="hidden" name="Language" value="RU">
				<input type="hidden" name="OrderComment" value="Оплата счета N <?php echo $order_row['shop_order_account_number']?>">
				<input type="hidden" name="Delay" value="0">

				<input type="hidden" name="URL_RETURN" value="<?php echo $handler_url?>">

				<!-- Производить оплату по кредитной карте -->
				<input type="hidden" type="text" name="CardPayment" value="<?php echo $this->use_credit_card ?>">

				<!-- оплата кредитной картой с использованием -->
				<input type="hidden" type="text" name="AssistIDPayment" value="<?php echo $this->use_credit_card ?>">

				<!-- Использовать платежную систему WebMoney Transfer -->
				<input type="hidden" type="text" name="WMPayment" value="1">

				<!-- Использовать платежную систему YandexMoney -->
				<input type="hidden" type="text" name="YMPayment" value="1">

				<!-- Использовать платежную систему QIWI -->
				<input type="hidden" type="text" name="QIWIPayment" value="1">

				<!-- Оплата с помощью средств на счету мобильного телефона (оператор МТС) -->
				<input type="hidden" type="text" name="QIWIMtsPayment" value="1">

				<!-- Оплата с помощью средств на счету мобильного телефона (оператор Мегафон) -->
				<input type="hidden" type="text" name="QIWIMegafonPayment" value="1">

				<!-- Оплата с помощью средств на счету мобильного телефона (оператор БиЛайн) -->
				<input type="hidden" type="text" name="QIWIBeelinePayment" value="1">

				<input type="hidden" name="Lastname" value="<?php echo htmlspecialchars($order_row['shop_order_users_surname'])?>">
				<input type="hidden" name="Firstname" value="<?php echo htmlspecialchars($order_row['shop_order_users_name'])?>">
				<input type="hidden" name="Middlename" value="<?php echo htmlspecialchars($order_row['shop_order_users_patronymic'])?>">

				<input type="hidden" name="Email" value="<?php echo htmlspecialchars($order_row['shop_order_users_email'])?>">
				<input type="hidden" name="Address" value="<?php echo htmlspecialchars($city_name)?>, <?php echo htmlspecialchars($order_row['shop_order_address'])?>">
				<input type="hidden" name="WorkPhone" value="<?php echo htmlspecialchars($order_row['shop_order_phone'])?>">

				<input type="hidden" name="City" value="<?php echo htmlspecialchars($city_name)?>">
				<input type="hidden" name="Zip" value="<?php echo htmlspecialchars($order_row['shop_order_index'])?>">

				<input type="submit" name="Submit" value="Оплатить <?php echo $sum?> <?php echo $currency_row['shop_currency_name']?>">
				</form>
				<?php
			}
		}
	}

	/**
	 * Изменение статуса заказа. Позволяет пользователю внедрять собственные
	 * обработчики при изменении статуса.
	 *
	 * @param array $param массив атрибутов
	 * - $param['shop_order_id'] идентификатор заказа
	 * - $param['prev_order_row'] информация о предыдущем состоянии заказа (доступно не всегда)
	 * - $param['action'] выполняемое действие над заказом, может принимать значения:
	 * edit (редактирование заказа), cancel (отмена заказа),
	 * status (изменение статуса заказа), delete (удаление заказа),
	 * edit_item (редактирование товара в заказе), delete_item (удаление товара в заказе)
	 */
	function ChangeStatus($param = array())
	{
		// Если произошло изменение статуса или
		if (isset($param['action']) && in_array($param['action'], array('status', 'edit')))
		{
			$shop_order_id = to_int($param['shop_order_id']);

			$shop = & singleton('shop');

			$order_row = $shop->GetOrder($shop_order_id);

			// Получаем информацию о магазине
			$shop_id = to_int($order_row['shop_shops_id']);

			$shop_row = $shop->GetShop($shop_id);

			$structure = & singleton('Structure');
			$structure_row = $structure->GetStructureItem(to_int($shop_row['structure_id']));

			$lib = new lib();
			$LA = $lib->LoadLibPropertiesValue(to_int($structure_row['lib_id']), to_int($structure_row['structure_id']));

			if ($order_row)
			{
				$DateClass = new DateClass();
				$date_str = $DateClass->datetime_format($order_row['shop_order_date_time']);
			}
			else
			{
				$date_str = '';
			}

			// Если предыдущий статус заказа был 1, то меняем тему на подтверждение
			if (to_int($order_row['shop_order_status_of_pay']) == 1)
			{
				$admin_subject = $GLOBALS['MSG_shops']['shop_order_confirm_admin_subject'];
				$user_subject = $GLOBALS['MSG_shops']['shop_order_confirm_user_subject'];
			}
			else
			{
				$admin_subject = $GLOBALS['MSG_shops']['shop_order_admin_subject'];
				$user_subject = $GLOBALS['MSG_shops']['shop_order_user_subject'];
			}

			$not_paid = isset($param['prev_order_row']) && $param['prev_order_row']['shop_order_status_of_pay'] == 0;

			// Письмо отправляем только при установке статуса активности для заказа
			if (to_int($order_row['shop_order_status_of_pay']) == 1 && $not_paid)
			{
				if (trim(to_str($order_row['shop_order_account_number'])) != '')
				{
					$shop_order_account_number = trim(to_str($order_row['shop_order_account_number']));
				}
				else
				{
					$shop_order_account_number = $shop_order_id;
				}

				/* Отправляем письмо заказчику */
				$shop->SendMailAboutOrder($shop_id,
				$shop_order_id,
				$order_row['site_users_id'],
				to_str($LA['xsl_letter_to_admin']),
				to_str($LA['xsl_letter_to_user']),
				$order_row['shop_order_users_email'],
				array('admin-content-type' => 'html',
				'user-content-type' => 'html',
				'admin-subject' => sprintf($admin_subject, $shop_order_account_number, $shop_row['shop_shops_name'], $date_str),
				'user-subject' => sprintf($user_subject, $shop_order_account_number, $shop_row['shop_shops_name'], $date_str),
				'email_from_admin' => $order_row['shop_order_users_email']));
			}
		}
	}
}
?>